import os
import time
import inspect
import syslog
import sys

GREEN = '\033[0;32m'
YELLOW = '\033[0;33m'
RED = '\033[0;31m'
NORMAL = '\033[0m'
LIGHT_BLUE = '\033[0;94m'

USE_SYSLOG = False

def success(p):
    line = inspect.currentframe().f_back.f_lineno
    file = os.path.basename(inspect.getfile( inspect.currentframe().f_back ))
    print("%f %s:%d %s%s%s" % ( time.time(), file, line, GREEN, p, NORMAL ))
    if USE_SYSLOG:
        syslog.syslog("%s:%d %s" % (file, line, p))

def error(p):
    line = inspect.currentframe().f_back.f_lineno
    file = os.path.basename(inspect.getfile( inspect.currentframe().f_back ))
    print("%f %s:%d %s%s%s" % ( time.time(), file, line, RED, p, NORMAL ))
    if USE_SYSLOG:
        syslog.syslog("%s:%d %s" % (file, line, p))

def warning(p):
    line = inspect.currentframe().f_back.f_lineno
    file = os.path.basename(inspect.getfile( inspect.currentframe().f_back ))
    print("%f %s:%d %s%s%s" % ( time.time(), file, line, YELLOW, p, NORMAL ))
    if USE_SYSLOG:
        syslog.syslog("%s:%d %s" % (file, line, p))

def info(p):
    line = inspect.currentframe().f_back.f_lineno
    file = os.path.basename(inspect.getfile( inspect.currentframe().f_back ))
    print("%f %s:%d %s%s%s" % ( time.time(), file, line, LIGHT_BLUE, p, NORMAL ))
    if USE_SYSLOG:
        syslog.syslog("%s:%d %s" % (file, line, p))

def redirect_stderr_to_syslog(name):
    import popen2
    (a,b)=popen2.popen2('logger -t "%s[%u]: STDERR"' % (name,os.getpid()))
    os.dup2(b.fileno(),sys.stderr.fileno())

